/*
 * Copyright (c) 2014, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include <mqx.h>
#include <bsp.h>
/* Task IDs */
#define HELLO_TASK 5
#define WORLD_TASK 6
extern void hello_task(uint32_t);
extern void world_task(uint32_t);
const TASK_TEMPLATE_STRUCT MQX_template_list[] =
{
		/* Task Index, Function, Stack, Priority, Name, Attributes,
Time Slice */

		{WORLD_TASK, world_task, 700, 9,"world", MQX_AUTO_START_TASK, 0, 0},
		{HELLO_TASK, hello_task, 700, 8, "hello", 0, 0, 0},
		{0}
};



/*TASK*-----------------------------------------------------
 *
 * Task Name : world_task
 * Comments :
 * This task creates hello_task and then prints " World ".
 *
 *END*-----------------------------------------------------*/
void world_task(uint32_t initial_data)
{
	_task_id hello_task_id;
	hello_task_id = _task_create(0, HELLO_TASK, 0);
	if (hello_task_id == MQX_NULL_TASK_ID) {
		printf ("\n Could not create hello_task\n");
	} else {
		printf(" World \n");
	}
	_task_block();
}
/*TASK*-----------------------------------------------------
 *
 * Task Name : hello_task
 * Comments :
 * This task prints " Hello".
 *
 *END*-----------------------------------------------------*/
void hello_task(uint32_t initial_data)
{
	uint8_t i = 0;
	while(1)
	{

		printf("\n%d Hello World\n",i);
		i++;
		_time_delay(500);
	}
	_task_block();
}
/* EOF */
